// La politique de cette colonie est de stocker la nourriture 
// dans 6 garde-mangers de la fourmilire qu'elle dfend contre les 
// intrusions ennemies.
//
// Des marques de plus en plus prononces sont mises sur les chemins emprunts.
//
// En plus, elle envoie quelques fourmis pour essayer de piquer la nourriture
// chez l'ennemie.

tourner = (flip(2).lturn) + rturn

suivre_marque =
  marker[5](ahead).move +
  marker[5](lahead).lturn.move +
  marker[5](rahead).rturn.move +
  marker[4](ahead).move.mark(5) +
  marker[4](lahead).lturn.move.mark(5) +
  marker[4](rahead).rturn.move.mark(5) +
  marker[3](ahead).move.mark(4) +
  marker[3](lahead).lturn.move.mark(4) +
  marker[3](rahead).rturn.move.mark(4) +
  marker[2](ahead).move.mark(3) +
  marker[2](lahead).lturn.move.mark(3) +
  marker[2](rahead).rturn.move.mark(3) +
  marker[1](ahead).move.mark(2).unmark(1) +
  marker[1](lahead).lturn.move.mark(2) +
  marker[1](rahead).rturn.move.mark(2) +
  marker[0](ahead).move.mark(1).unmark(0) +
  marker[0](lahead).lturn.move.mark(1) +
  marker[0](rahead).lturn.move.mark(1)

augmenter_marque =
  marker[4](here).mark(5) +
  marker[3](here).mark(4) +
  marker[2](here).mark(3) +
  marker[1](here).mark(2) +
  marker[0](here).mark(1) +
  ~marker[5](here).mark(0)

se_promener = move.augmenter_marque + (tourner.move?)

marcher_vers_maison = suivre_marque + (tourner.move?)

demi_tour = lturn.lturn.lturn

regarder = (~home(ahead)).(~home(lahead)).(~home(rahead))
garde_manger = 
  (regarder + 
   (lturn.regarder) +
   (lturn.regarder) +
   (lturn.regarder) +
   (lturn.regarder) +
   (lturn.regarder))

marche_aleatoire_dans_maison = (home(ahead).move) + tourner

proteger_garde_manger = (lturn.friendwithfood(ahead))?

trouver_garde_manger =
  ((home(ahead).food(ahead).(move?)) +
   (home(lahead).food(lahead).lturn.(move?)) +
   (home(rahead).food(rahead).rturn.(move?)) +
   (home(ahead).move.garde_manger))
  !marche_aleatoire_dans_maison

rapporter_nourriture = 
  (home(ahead).trouver_garde_manger.drop.proteger_garde_manger)
  !marcher_vers_maison

gober = move.pickup

prendre_nourriture = 
  ((food(ahead).~home(ahead)) +
   (food(lahead).~home(lahead).lturn) +
   (food(rahead).~home(rahead).rturn))
  .gober

aller_fourmiliere_adverse = 
  (foehome(ahead).move + 
   foehome(lahead).lturn.move + 
   foehome(rahead).rturn.move)

se_promener_chez_adversaire = (foehome(ahead).move) + tourner

prendre_nourriture_adverse =
  (((food(ahead).foehome(ahead)) +
   (food(lahead).foehome(lahead).lturn) +
   (food(rahead).foehome(rahead).rturn)).
   gober)
  !se_promener_chez_adversaire

sortir = 
  ((~foehome(ahead)).(move?) +
   (~foehome(lahead)).lturn.(move?) +
   (~foehome(rahead)).rturn.(move?))

voleuse = 
  (aller_fourmiliere_adverse.prendre_nourriture_adverse.sortir.demi_tour)
  !se_promener

chercheur = (prendre_nourriture.demi_tour.rapporter_nourriture)!se_promener

(flip(9).(voleuse*)) + (chercheur*)
